' Set Option Strict on as this really speeds
' Up performance in vb.net and helps you create
' good code
Option Strict On

Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Threading
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.IO

Imports System.Text
Imports System.Configuration
Imports System.Environment


Public Class Server
    Private Stream As Integer

    Private mySocket As Socket
    Private _Dir As String
    Private _Name As String
    Private StreamName As String
    Private StopThreads As Boolean = False


    Public Sub New(ByVal s As Socket, ByVal dir As String, ByVal Name As String)
        mySocket = s
        _Dir = dir
        _Name = Name
    End Sub
    Public Function CheckIsMaster(ByVal ConMulti As Integer, ByVal ConNum As Integer) As Boolean
        Dim i As Integer
        Dim tmparray(UBound(Module1.ArrConnections)) As String
        For i = 0 To UBound(tmparray)
            tmparray(i) = Module1.ArrConnections(i).NotConnected.ToString & "-|-" & Module1.ArrConnections(i).ConnectionNumberMultiplier.ToString & "-|-" & Module1.ArrConnections(i).ConnectionNumber.ToString
        Next
        Array.Sort(tmparray)
        ' For i = 0 To UBound(tmparray)
        '   MsgBox(tmparray(0))
        Dim sp() As String = Split(tmparray(0), "-|-")
        '  Module1.ArrConnections(i).NotConnected = CInt(sp(0))
        '  Module1.ArrConnections(i).ConnectionNumberMultiplier = CInt(sp(1))
        '   Module1.ArrConnections(i).ConnectionNumber = CInt(sp(2))
        If ConMulti = CInt(sp(1)) Then
            If ConNum = CInt(sp(2)) Then
                Return True
            End If



        End If
        'Next
        Return False
    End Function
    Public Sub HandleConnection()

        Dim iStartPos As Integer = 0
        Dim sRequest, sDirName, sRequestedFile, sErrorMessage, sLocalDir As String
        Dim LastFileSize As Long = 9999999999999


        Dim bReceive As Byte()
        ReDim bReceive(1024)

        'Receive the request into a byte array
        Dim i As Integer = mySocket.Receive(bReceive, bReceive.Length, 0)


        ' Convert the byte array to a string
        Dim sbuffer As String = Encoding.ASCII.GetString(bReceive)


        iStartPos = sbuffer.IndexOf("HTTP", 1)

        '  Get the HTTP text and version e.g. it will return "HTTP/1.1"
        Dim sHttpVersion As String = sbuffer.Substring(iStartPos, 8)



        ' the web server only accepts get requests.
        If Mid(LCase(sbuffer), 1, 3) <> "get" Then
            'f not GET request then close socket and exit
            mySocket.Close()
            ' NumConnections -= 1
            Return
        End If


        If TotalConnections > UBound(ArrConnections) Then TotalConnections = 0 : Module1.TotalConnectionsMultiplier += 1
        If TotalConnectionsMultiplier > 999999999 Then TotalConnectionsMultiplier = 0
        Dim ConNumber, ConNumberMulti As Integer
        ConNumber = TotalConnections
        ConNumberMulti = TotalConnectionsMultiplier
        ArrConnections(ConNumber).ConnectionNumberMultiplier = ConNumberMulti
        ArrConnections(ConNumber).ConnectionNumber = ConNumber
        ArrConnections(ConNumber).NotConnected = 0
        ArrConnections(ConNumber).StartedTime = Now
        ArrConnections(ConNumber).IPADD = (CType(mySocket.RemoteEndPoint, IPEndPoint).Address).ToString

        '  Dim addfamily As IPAddress = CType(mySocket.RemoteEndPoint.AddressFamily, IPAddress)

        ' ArrConnections(ConNumber).IPADD = 
        Dim ismaster As Boolean = False
        ' MsgBox(Me.CheckIsMaster(ConNumberMulti, ConNumber).ToString())
        TotalConnections += 1

        NumConnections += 1
        Dim sentheader As Boolean = False
        ' Create File Stream of filename

        Dim BytesSent As Long = 0
        ' Create byte array buffer
        '  Dim bytes As Byte()
        Dim i3 As Integer
        Dim str As String
        Dim fs As FileStream = Nothing
        Dim reader As BinaryReader
        Randomize()

        StreamName = Trim(CStr(CInt(Rnd() * 999999999))) & ".mp3"
        StreamName = "Stream" & ".mp3"
        str = Application.StartupPath & "\tmp_streams\" & StreamName

        If Module1.EncoderThread Is Nothing Then
            EncoderThread = New Thread(AddressOf ThreadEncode)
            EncoderThread.IsBackground = True
            EncoderThread.Priority = ThreadPriority.BelowNormal
            EncoderThread.Start()
            System.Threading.Thread.CurrentThread.Sleep(250)
        End If

        Dim LastCreationtime As New Date(1910, 1, 1)

        str = Application.StartupPath & "\tmp_streams\" & countfiles.ToString & "_" & StreamName
        Do While Not DoStop
            '
            If Not mySocket.Connected Then Exit Do
            If Not File.Exists(str) Then System.Threading.Thread.CurrentThread.Sleep(100) : GoTo ew
            Dim finfo As New FileInfo(str)

            If LastCreationtime < finfo.CreationTime Then
                LastCreationtime = finfo.CreationTime


                If Not fs Is Nothing Then


                    fs.Flush()
                    fs.Close()
                    reader.Close()

                    reader = Nothing
                    '  fs = Nothing

                End If
                fs = New FileStream(str, FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite)

                reader = New BinaryReader(fs)


                LastFileSize = 0
                BytesSent = 0
                finfo = New FileInfo(str)
            End If

            If Not EncodingS OrElse (fs.Length > BytesSent + 100000) Then
                Dim bytes() As Byte
                bytes = reader.ReadBytes(8193)
                If UBound(bytes) >= 0 Then
                    BytesSent += UBound(bytes)
                    If Not sentheader Then
                        If Not SendHeader(sHttpVersion, "", 0, " 200 OK") Then GoTo exithandle
                        sentheader = True
                    End If
                    Dim bytes2(UBound(bytes)) As Byte
                    Dim lastbytes As Integer = -1
                    lastbytes = 0
                    Dim countbytes As Integer = 0
                    countbytes = 0
                    Do While countbytes < UBound(bytes) + 1
                        ReDim bytes2(UBound(bytes) - countbytes)
                        Dim ix As Integer
                        For ix = 0 To UBound(bytes2)
                            bytes2(ix) = bytes(countbytes + ix)
                        Next
                        lastbytes = SendToBrowser(bytes2)
                        countbytes += lastbytes
                        System.Threading.Thread.CurrentThread.Sleep(200)
                        If Not mySocket.Connected Then
                            StopThreads = True
                            Exit Do
                        End If
                        If DoStop Then Exit Do
                    Loop
                Else
                    'MsgBox("")
                    If Me.CheckIsMaster(ConNumberMulti, ConNumber) Then
                        If countfiles > 5 Then countfiles = -1
                        countfiles += 1


                        NewEncode = True
                        EncodingS = True
                        System.Threading.Thread.CurrentThread.Sleep(100)
                        '  Beep()
                    End If
                    str = Application.StartupPath & "\tmp_streams\" & countfiles.ToString & "_" & StreamName
                End If
            Else
                System.Threading.Thread.CurrentThread.Sleep(200)
            End If

         
ew:
            If DoStop Then Exit Do
            If Not mySocket.Connected Then
                Exit Do
            End If
        Loop
ExitHandle:

        Try
            mySocket.Close()
        Catch
        End Try
        If Not fs Is Nothing Then


            fs.Flush()
            fs.Close()
            reader.Close()

            reader = Nothing
            fs = Nothing

        End If
        StopThreads = True
        Threading.Thread.CurrentThread.Sleep(3000)

        ArrConnections(ConNumber).NotConnected = 1
        NumConnections -= 1

    End Sub

    Private Function EncodeStream(ByVal EncStream As Integer, ByVal EncCmd As String) As Boolean

        Try
            If Not Bass.BASS_Encode_Start(EncStream, EncCmd, 0, 0, 0) <> 0 Then

                NewEncode = True
                Return False
            End If

        Catch
            Try
                Bass.BASS_Encode_Stop(EncStream)
            Catch
            End Try
            Try
                Bass.BASS_StreamFree(EncStream)
            Catch
            End Try
            Return False
        End Try
        'MsgBox(Bass.BASS_ChannelIsActive(EncStream).ToString)

        Dim buf(11000) As Byte
        Dim l As Long
        Dim cnt As Long
        Dim top As Integer
        Dim tosize As Integer
        '  Bass.BASS_ChannelPlay(EncStream)
        '   MsgBox(Bass.BASS_ChannelIsActive(EncStream).ToString)
        While Bass.BASS_ChannelIsActive(EncStream) = Bass.PlayingMode.Playing
            ' Beep()
            If DoStop Then Exit While

            ReDim buf(6000)
            Try
                tosize = (Bass.BASS_ChannelGetData(EncStream, buf(0), UBound(buf) + 1) - 1)
            Catch
                Try
                    Bass.BASS_Encode_Stop(EncStream)
                Catch
                End Try
                Try
                    Bass.BASS_StreamFree(EncStream)
                Catch
                End Try
            End Try
            If tosize = -1 Then
                System.Threading.Thread.CurrentThread.Sleep(10)
                GoTo ew
            End If
            Try
                ReDim Preserve buf(tosize)
            Catch
                Try
                    Bass.BASS_Encode_Stop(EncStream)
                Catch
                End Try
                Try
                    Bass.BASS_StreamFree(EncStream)
                Catch
                End Try
            End Try
            Try
                l = Bass.BASS_Encode_Write(EncStream, buf(0), UBound(buf))
            Catch
                Try
                    Bass.BASS_Encode_Stop(EncStream)
                Catch
                End Try
                Try
                    Bass.BASS_StreamFree(EncStream)
                Catch
                End Try
                Exit Function
            End Try
            System.Threading.Thread.Sleep(10)

            Dim docancel As Boolean = False
            docancel = DoStop
            If docancel Then
                Try
                    Bass.BASS_Encode_Stop(EncStream)
                Catch
                End Try
                Return False
            End If

ew:
            If Bass.BASS_ChannelIsActive(EncStream) = Bass.PlayingMode.Playing Then
            Else
                Exit While
            End If
            '    If StopThreads Then Exit While
        End While

        System.Threading.Thread.Sleep(100)
        Try
            Bass.BASS_Encode_Stop(EncStream)
        Catch
        End Try
        Try
            Bass.BASS_StreamFree(EncStream)
        Catch
        End Try
        Return True

    End Function
    Private Sub ThreadEncode()
        Dim enccmd As String
        Dim CountPlayed As Integer = 0
        Dim str As String
        Do While Not DoStop
            '  If StopThreads Then Return
            If DoStop Then Return
            For Each str In GetAllFiles(_Dir, "*.*", "*.ogg;*.mp3", True)
                If CountPlayed > Module1.StartPlayListPosition Then
                    Module1.StartPlayListPosition = CountPlayed
                End If
                CountPlayed += 1
                If CountPlayed >= Module1.StartPlayListPosition Then


dagain:

                    '   If StopThreads Then Return
                    If DoStop Then Return
                    If NewEncode Then
                        NewEncode = False
                        Stream = 0
                        If DoStop Then Exit For
                        enccmd = "lame " & "--silent --priority 1 -S -b " & "128" & " " & "- " & Chr(34) & Application.StartupPath & "\tmp_streams\" & countfiles.ToString & "_" & StreamName & Chr(34) & ""
                        Stream = Bass.BASS_StreamCreateFile(Bass.BassBool.BassFalse, str, 0, 0, Bass.StreamCreateFile.BASS_STREAM_DECODE Or Bass.StreamCreateFile.BASS_STREAM_AUTOFREE)


                        If Stream <> 0 Then
                            ' MsgBox("0")
                            Dim StreamTest As Integer = Bass.BASS_StreamCreateFile(Bass.BassBool.BassFalse, str, 0, 0, Bass.StreamCreateFile.BASS_STREAM_DECODE Or Bass.StreamCreateFile.BASS_STREAM_AUTOFREE)
                            Dim passedtest As Boolean = False
                            Dim cinfo As Bass.BASS_CHANNELINFO
                            ' If Bass.BASS_ChannelPlay(StreamTest) <> 0 Then
                            'MsgBox("1")
                            If Bass.BASS_ChannelGetInfo(StreamTest, cinfo) = Bass.BassBool.BassTrue Then
                                '  MsgBox("1")
                                If cinfo.chan >= 2 Then
                                    passedtest = True
                                    '   MsgBox("3")
                                End If
                            End If
                            Bass.BASS_ChannelStop(StreamTest)
                            Bass.BASS_StreamFree(StreamTest)
                            'End If


                            If passedtest Then
                                EncodingS = True
                                If Me.EncodeStream(Stream, enccmd) Then
                                    EncodingS = False
                                Else
                                    NewEncode = True
                                End If
                                Dim i As Integer = 0
                                If countfiles > 3 Then

                                    For i = 0 To countfiles - 3
                                        Try
                                            If File.Exists(Application.StartupPath & "\tmp_streams\" & i.ToString & "_" & StreamName) Then
                                                File.Delete((Application.StartupPath & "\tmp_streams\" & i.ToString & "_" & StreamName))
                                            End If
                                        Catch
                                        End Try

                                    Next
                                Else
                                    Try
                                        If File.Exists(Application.StartupPath & "\tmp_streams\" & (countfiles + 3).ToString & "_" & StreamName) Then
                                            File.Delete((Application.StartupPath & "\tmp_streams\" & (countfiles + 3).ToString & "_" & StreamName))
                                        End If
                                    Catch
                                    End Try


                                End If

                                System.Threading.Thread.CurrentThread.Sleep(100)
                            Else
                                NewEncode = True
                            End If
                        Else
                            NewEncode = True
                        End If
                    Else
                        System.Threading.Thread.CurrentThread.Sleep(100)
                        GoTo dagain
                    End If
                End If
                System.Threading.Thread.CurrentThread.Sleep(100)
            Next
            System.Threading.Thread.CurrentThread.Sleep(100)
            Module1.StartPlayListPosition = 0
            'CountPlayed = 0
        Loop

    End Sub
    Private Function SendHeader(ByVal sHttpVersion As String, ByVal sMIMEHeader As String, ByVal iTotBytes As Integer, ByVal sStatusCode As String) As Boolean

        Dim sBuffer As String = ""
        sBuffer = sBuffer & sHttpVersion & " 200" & vbNewLine
        sBuffer = sBuffer & "icy-notice1:<BR>This stream requires WinAmp or another compatible player<BR>" & vbCrLf
        sBuffer = sBuffer & "icy-notice2:VB.net ICY Server<BR>" & vbCrLf
        sBuffer = sBuffer & "icy-name:" & _Name.ToString & vbCrLf
        sBuffer = sBuffer & "icy-genre:Test" & vbCrLf
        sBuffer = sBuffer & "icy-url:http://localhost:8282" & vbCrLf
        sBuffer = sBuffer & "Content-Type:" & "audio/mpeg" & vbCrLf
        sBuffer = sBuffer & "icy-pub:0" & vbCrLf
        sBuffer = sBuffer & "icy-br:128" & vbCrLf
        sBuffer = sBuffer & "icy-metaint:0" & vbCrLf & vbCrLf



        Try
            Dim bSendData As Byte() = Encoding.ASCII.GetBytes(sBuffer)

            SendToBrowser(bSendData)
        Catch
            Return False
        End Try
        Return True

    End Function

    Private Sub SendToBrowser(ByVal sData As String)

        SendToBrowser(Encoding.ASCII.GetBytes(sData))
    End Sub


    Private Function SendToBrowser(ByVal bSendData As Byte()) As Integer

        Dim numbytes As Integer

        If (mySocket.Connected) Then

            Try
                numbytes = mySocket.Send(bSendData, bSendData.Length, 0)
            Catch
            End Try

        Else

        End If
        Return numbytes
    End Function
End Class
